#include <genlib.h>

main ()

{

/* Instruction decoder */
DEF_LOFIG ("instruction_decoder");
/* declaration of the cell's external connectors */
LOCON ("I[8:0]",'I',"i[8:0]");
LOCON ("COUT15",'I',"cout15");
LOCON ("COUT14",'I',"cout14");
LOCON ("SUM15",'I',"sum15");
LOCON ("SIGN",'O',"sign");
LOCON ("OVR",'O',"ovr");
LOCON ("COUT",'O',"cout");
LOCON ("N[12:0]",'O',"n[12:0]");
LOCON ("RAM_WE",'O',"ram_we");
LOCON ("CLK",'I',"clk");
LOCON ("CLK_A",'O',"clk_a");
LOCON ("CLK_B",'O',"clk_b");
LOCON ("WE_A",'O',"we_a");
LOCON ("WE_B",'O',"we_b");
LOCON ("VDD",'I',"vdd");
LOCON ("VSS",'I',"vss");

/* ALU function decoder */

LOINS ("n1_y","not1_I","i[3]","ni3","vdd","vss",0);
LOINS ("n1_y","not2_I","i[4]","ni4","vdd","vss",0);
LOINS ("n1_y","not3_I","i[5]","ni5","vdd","vss",0);
LOINS ("no2_y","nor1_I","ni[4]","i[5]","x00","vdd","vss",0);
LOINS ("no2_y","nor2_I","x00","ni[3]","n[0]","vdd","vss",0);
LOINS ("no3_y","nor3_I","ni[4]","i[5]","i[3]","n[1]","vdd","vss",0);
LOINS ("no2_y","nor4_I","ni[4]","ni[3]","x01","vdd","vss",0);
LOINS ("no2_y","nor5_I","x01","i[5]","n[2]","vdd","vss",0);
LOINS ("no3_y","nor6_I","ni[4]","i[5]","ni[3]","n[3]","vdd","vss",0);
LOINS ("no2_y","nor7_I","ni[5]","i[4]","n[4]","vdd","vss",0);
LOINS ("no2_y","nor8_I","ni[5]","ni[4]","n[5]","vdd","vss",0);
LOINS ("xr2_y","xor_ovr","cout","cout14","ovr","vdd","vss",0);
LOINS ("p1_y","sign_buff","sum15","sign","vdd", "vss", 0);
LOINS ("p1_y","cout_buff","cout15","cout","vdd", "vss", 0);


/* ALU input decoder */

LOINS ("n1_y","not4_I","i[0]","ni0","vdd","vss",0);
LOINS ("n1_y","not5_I","i[1]","ni1","vdd","vss",0);
LOINS ("n1_y","not6_I","i[2]","ni2","vdd","vss",0);
LOINS ("na2_y","nand2_I","ni[2]","i[1]","x02","vdd","vss",0);
LOINS ("na2_y","nand3_I","x02","x09","n[12]","vdd","vss",0);
LOINS ("na2_y","nand4_I","i[2]","i[1]","x03","vdd","vss",0);
LOINS ("na2_y","nand5_I","ni[2]","ni[0]","x04","vdd","vss",0);
LOINS ("na2_y","nand7_I","x03","x04","n[10]","vdd","vss",0);
LOINS ("na2_y","nand8_I","ni[2]","i[0]","x05","vdd","vss",0);
LOINS ("na2_y","nand9_I","x05","x06","n[11]","vdd","vss",0);
LOINS ("na2_y","nand10_I","i[1]","i[0]","x06","vdd","vss",0);
LOINS ("na3_y","nand6_I","i[2]","ni[1]","ni[0]","x09","vdd","vss",0);
LOINS ("no2_y","nor10_I","i[2]","i[1]","n[9]","vdd","vss",0);


/* ALU destination decoder */

LOINS ("n1_y","not7_I","i[7]","ni7","vdd","vss",0);
LOINS ("n1_y","not8_I","i[8]","ni8","vdd","vss",0);
LOINS ("n1_y","not9_I","i[9]","ni9","vdd","vss",0);
LOINS ("na2_y","nand11_I","ni[8]","ni[7]","ram_we","vdd","vss",0);
LOINS ("na2_y","nand13_I","ni[7]","ni[6]","x07","vdd","vss",0);
LOINS ("na2_y","nand14_I","i[8]","ni[6]","x08","vdd","vss",0);
LOINS ("na2_y","nand15_I","x07","x08","n[7]","vdd","vss",0);
LOINS ("na3_y","nand12_I","ni[8]","i[7]","ni[6]","n[6]","vdd","vss",0);
LOINS ("no2_y","nor9_I","ni[7]","ni[8]","n[8]","vdd","vss",0);


/* Clock signals and write enable signals for latch A & b */

LOINS ("n1_y","not10_I","clk","clk_a","vdd","vss",0);
LOINS ("n1_y","not11_I","clk","clk_b","vdd","vss",0);
LOINS ("p1_y","buff_a","vdd","we_a","vdd","vss",0);
LOINS ("p1_y","buff_b","vdd","we_b","vdd","vss",0);

SAVE_LOFIG();

exit(0);
}
