#include <fpgen.h>
#include <genlib.h>

main ()

{

/* Data Path generation */
DP_DEFLOFIG ("data_path",16,LSB_INDEX_ZERO);
/* declaration of the cell's external connectors */
DP_LOCON ("D[15:0]",IN,"d[15:0]");
DP_LOCON ("Y[15:0]",OUT,"y[15:0]");
DP_LOCON ("CN",IN,"cin");
DP_LOCON ("COUT15",OUT,"cout15");
DP_LOCON ("COUT14",OUT,"cout14");
DP_LOCON ("ZERO",OUT,"zero");
DP_LOCON ("SUM15",OUT,"sum[15]");
DP_LOCON ("N[12:0]",IN,"n[12:0]");
DP_LOCON ("F_I0",IN,"f_i0");
DP_LOCON ("F_I15",IN,"f_i15");
DP_LOCON ("ACC_I0",IN,"acc_i0");
DP_LOCON ("ACC_I15",IN,"acc_i15");
DP_LOCON ("F_O0",OUT,"f[0]");
DP_LOCON ("F_O15",OUT,"f[15]");
DP_LOCON ("ACC_O0",OUT,"acc[0]");
DP_LOCON ("ACC_O15",OUT,"acc[15]");
DP_LOCON ("RAM_IN[15:0]",OUT,"ram_in[15:0]");
DP_LOCON ("RAM_A[15:0]",IN,"ram_a[15:0]");
DP_LOCON ("RAM_B[15:0]",IN,"ram_b[15:0]");
DP_LOCON ("CLK",IN,"clk");
DP_LOCON ("WE_A",IN,"we_a");
DP_LOCON ("WE_B",IN,"we_b");
DP_LOCON ("CLK_A",IN,"clk_a");
DP_LOCON ("CLK_B",IN,"clk_b");
DP_LOCON ("VDD",IN,"vdd");
DP_LOCON ("VSS",IN,"vss");

/* instanciating adder/subtractor */
DP_IMPORT ("addsub","addsub_16","r[15:0]",
                                "s[15:0]",
                                "cin","co[15:0]",
                                "cout15","cout14",
                                "sum[15:0]",EOL);

/*adding logical functions for ALU */

DP_XOR2("xor1_alu",16,0,"r[15:0]",
                        "n[0]","n[0]","n[0]","n[0]","n[0]","n[0]",
                        "n[0]","n[0]","n[0]","n[0]","n[0]","n[0]",
                        "n[0]","n[0]","n[0]","n[0]","x0[15:0]",EOL);

DP_XOR2("xor2_alu",16,0,"s[15:0]",
                        "n[1]","n[1]","n[1]","n[1]","n[1]","n[1]",
                        "n[1]","n[1]","n[1]","n[1]","n[1]","n[1]",
                        "n[1]","n[1]","n[1]","n[1]","x1[15:0]",EOL);

DP_INV("not1_alu",16,0,1,"x0[15:0]","alu1[15:0]",EOL);

DP_INV("not2_alu",16,0,1,"x1[15:0]","alu2[15:0]",EOL);

DP_NOR2("nor2_alu",16,0,1,"alu1[15:0]","alu2[15:0]","alu9[15:0]",EOL);

DP_NAND2("nand2_alu",16,0,1,"alu9[15:0]","n[3]","n[3]","n[3]","n[3]","n[3]",
                            "n[3]","n[3]","n[3]","n[3]","n[3]","n[3]","n[3]",
                            "n[3]","n[3]","n[3]","n[3]","alu6[15:0]",EOL);

DP_NOR2("nor1_alu",16,0,1,"x0[15:0]","x1[15:0]","alu3[15:0]",EOL);

DP_NAND2("nand3_alu",16,0,1,"alu3[15:0]","n[4]","n[4]","n[4]","n[4]","n[4]",
                            "n[4]","n[4]","n[4]","n[4]","n[4]","n[4]","n[4]",
                            "n[4]","n[4]","n[4]","n[4]","alu7[15:0]",EOL);

DP_XOR2("xor3_alu",16,0,"x0[15:0]","x1[15:0]","alu4[15:0]",EOL);

DP_NAND2("nand4_alu",16,0,1,"alu4[15:0]","n[5]","n[5]","n[5]","n[5]","n[5]",
                            "n[5]","n[5]","n[5]","n[5]","n[5]","n[5]","n[5]",
                            "n[5]","n[5]","n[5]","n[5]","alu8[15:0]",EOL);

DP_NAND2("nand1_alu",16,0,1,"s[15:0]","n[2]","n[2]","n[2]","n[2]","n[2]",
                            "n[2]","n[2]","n[2]","n[2]","n[2]","n[2]","n[2]",
                            "n[2]","n[2]","n[2]","n[2]","alu5[15:0]",EOL);

DP_AND3("and5_alu",16,0,1,"alu5[15:0]",
                          "alu6[15:0]",
                          "alu7[15:0]",
                          "alu10[15:0]",
                          "alu11[15:0]",EOL);

DP_AND2("and6_alu",16,0,1,"alu10[15:0]",
                          "alu8[15:0]",
                          "f[15:0]",
                          "alu12[15:0]",EOL);

DP_NUL("zero_detect",16,0,"f[15:0]","zero",EOL);


/* RAM input MUX */

DP_MUX3CS("ram_mux3",16,0,"n[8]","ni[8]",
                          "f[14:0]","f_i0",
                          "f_i15","f[15:1]",
                          "f[15:0]",
                          "ram_in[15:0]", EOL);

/* Accumulator input MUX */

DP_MUX3CS("acc_mux3",16,0,"i[7]","ni[8]",
                          "acc[14:0]","acc_i0",
                          "acc_i15","acc[15:1]",
                          "f[15:0]",
                          "bus3[15:0]", EOL);

/* Accumulator */

DP_PDFF("acc", 16, 0, "n[7]",
                      "clk",
                      "bus3[15:0]",
                      "acc[15:0]",
                      "bus4[15:0]", EOL);

/* Latch A */

DP_PDFF("reg_a", 16, 0, "we_a",
                        "clk_a",
                        "ram_a[15:0]",
                        "reg_a[15:0]",
                        "bus1[15:0]", EOL);

/* Latch B */
DP_PDFF("reg_b", 16, 0, "we_b",
                        "clk_b",
                        "ram_b[15:0]",
                        "reg_b[15:0]",
                        "bus2[15:0]", EOL);

/* 3:1 MUX for R input of ALU */

DP_MUX3CS("mux_r", 16, 0,  "n[12]","n[9]",
                           "const_0[15:0]",
                           "reg_a[15:0]",
                           "d[15:0]",
                           "r[15:0]", EOL);

/* 4:1 MUX for S input of ALU */

DP_CONST("const_zero", 16, 0, "0x00", "const_0[15:0]", EOL);

DP_MUX4CS("mux_s", 16, 0, "n[10]","n[11]",
                          "const_0[15:0]",
                          "acc[15:0]",
                          "reg_b[15:0]",
                          "reg_a[15:0]",
                          "s[15:0]", EOL);

/* 2:1 Output MUX */

DP_MUX2CS("mux_out", 16, 0, "n[6]",
                            "f[15:0]",
                            "reg_a[15:0]",
                            "y[15:0]", EOL);


DP_SAVLOFIG();

exit(0);
}



