#include <genlib.h>
#include <dpgen.h>
#define POWER "vdde","vdd","vsse","vss",0

int main ()
 {
  int i;

  GENLIB_DEF_LOFIG("chip");

  GENLIB_LOCON(  "data_in[7:0]", IN   ,"data_in[7:0]");
  GENLIB_LOCON(  "hadout[13:0]", OUT  , "hadout[13:0]");
  GENLIB_LOCON(  "read",  OUT   , "read" );
  GENLIB_LOCON(  "write", OUT   , "write");
  GENLIB_LOCON(  "empty", IN   , "empty");
  GENLIB_LOCON(  "full",  IN   , "full" );
  GENLIB_LOCON(  "test", IN   ,  "test");
  GENLIB_LOCON(  "scin", IN   ,  "scin");
  GENLIB_LOCON(  "scout", OUT   ,  "scout");
  GENLIB_LOCON(  "ck", IN   ,  "ck");
  GENLIB_LOCON(  "reset", IN   ,  "reset");
  GENLIB_LOCON(  "vdd", IN   ,  "vdd");
  GENLIB_LOCON(  "vss", IN   ,  "vss");
  GENLIB_LOCON("vdde", IN     , "vdde");
  GENLIB_LOCON("vsse", IN     , "vsse");
 

  GENLIB_LOINSE("circuit","hadamard",
				"data_in[7:0] => data_i[7:0]",
				"hadout[13:0] => hadout_i[13:0]",
				"read => read_i",
				"write => write_i",
				"empty => empty_i",
				"full => full_i",
				"test => test_i",
				"scin => scin_i",
				"scout => scout_i",
				"ck => ckc",
				"reset => reset_i",
				"vdd => vdd",
				"vss => vss",
				0 );

/* plot d'horloge externe */				
  GENLIB_LOINS("pck_sp","p_ck","ck","cki", POWER);

/* plots d'entres */
  GENLIB_LOINS("pi_sp","p_empty","empty","empty_i","cki", POWER );
  GENLIB_LOINS("pi_sp","p_full","full","full_i","cki", POWER );
  GENLIB_LOINS("pi_sp","p_test","test","test_i","cki", POWER );
  GENLIB_LOINS("pi_sp","p_scin","scin","scin_i","cki", POWER );
  GENLIB_LOINS("pi_sp","p_reset","reset","reset_i","cki", POWER );
 
  for (i=0;i<8;i++)
    GENLIB_LOINS("pi_sp",GENLIB_NAME("p_d%d",i), GENLIB_ELM("data_in",i),
GENLIB_ELM("data_i",i), "cki", POWER );


/* plots de sortie */
  GENLIB_LOINS("po_sp","p_read","read_i","read","cki", POWER );
  GENLIB_LOINS("po_sp","p_write","write_i","write","cki", POWER );
  GENLIB_LOINS("po_sp","p_scout","scout_i","scout","cki", POWER );
 
 for (i=0;i<14;i++)
    GENLIB_LOINS("po_sp",GENLIB_NAME("p_h%d",i), GENLIB_ELM("hadout_i",i),
GENLIB_ELM("hadout",i), "cki", POWER );

  
/* plots d'horloge */
  GENLIB_LOINS("pvddick_sp","p_vddick0","ckc","cki","vdde","vdd","vsse","vss",0);
  GENLIB_LOINS("pvssick_sp","p_vssick0","ckc","cki","vdde","vdd","vsse","vss",0);
//  GENLIB_LOINS("pvddick_sp","p_vddick1","ckc","cki","vdde","vdd","vsse","vss",0);
//  GENLIB_LOINS("pvssick_sp","p_vssick1","ckc","cki","vdde","vdd","vsse","vss",0);

  GENLIB_LOINS("pvddeck_sp","p_vddeck0","ckc","cki","vdde","vdd","vsse","vss",0);
  GENLIB_LOINS("pvddeck_sp","p_vddeck1","ckc","cki","vdde","vdd","vsse","vss",0);
  GENLIB_LOINS("pvsseck_sp","p_vsseck0","ckc","cki","vdde","vdd","vsse","vss",0);
  GENLIB_LOINS("pvsseck_sp","p_vsseck1","ckc","cki","vdde","vdd","vsse","vss",0);
  
  GENLIB_SAVE_LOFIG();

  exit (0);

 }
