// sstack_fpgen.c
// 3 implementacion de la pila de instrucciones
// JUNIO / 2000

#include <fpgen.h>

void main()
{
    // micropila
    DP_DEFLOFIG( "sstack_fpgen" , 16, LSB_INDEX_ZERO );
    
    // interfaz
    DP_LOCON( "D[15:0]" , IN , "D[15:0]" );
    DP_LOCON( "STACK_EN[7:0]" , IN , "EN[7:0]" );
    DP_LOCON( "STACK_EN_DATA[7:0]" , IN , "EN_DATA[7:0]" );   
    DP_LOCON( "CLK" , IN , "CLK");
    DP_LOCON( "Q[15:0]" , TRISTATE , "Q[15:0]" );
    
    //POWER
    DP_LOCON( "vdd" , IN , "vdd" );
    DP_LOCON( "vss" , IN , "vss" );
    
    //implementacion

    DP_INV( "inv0", 8, 0, 1, "EN_DATA[7:0]", "INV0OUT[7:0]", EOL );

    DP_INV( "inv1", 8, 0, 1, "INV0OUT[7:0]", "INV1OUT[7:0]", EOL );
    DP_INV( "inv2", 8, 0, 1, 
	    "CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK",
	    "INV2OUT[7:0]", EOL );
    
    DP_AND2( "and3", 8, 0, 1, "INV1OUT[7:0]", "INV2OUT[7:0]",
		"AND3OUT[7:0]", "N-AND3OUT[7:0]", EOL );

    DP_IMPORT( "dlatch_fpgen", "latch7", "D[15:0]", "AND3OUT[7]", 
    "Q7[15:0]", EOL);
    DP_BUSE( "tri7", 16, 0, "EN[7]", "Q7[15:0]", "Q[15:0]", EOL);  
    DP_IMPORT( "dlatch_fpgen", "latch6", "D[15:0]", "AND3OUT[6]", 
    "Q6[15:0]", EOL);
    DP_BUSE( "tri6", 16, 0, "EN[6]", "Q6[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch5", "D[15:0]", "AND3OUT[5]", 
    "Q5[15:0]", EOL);
    DP_BUSE( "tri5", 16, 0, "EN[5]", "Q5[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch4", "D[15:0]", "AND3OUT[4]", 
    "Q4[15:0]", EOL);
    DP_BUSE( "tri4", 16, 0, "EN[4]", "Q4[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch3", "D[15:0]", "AND3OUT[3]", 
    "Q3[15:0]", EOL);
    DP_BUSE( "tri3", 16, 0, "EN[3]", "Q3[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch2", "D[15:0]", "AND3OUT[2]", 
    "Q2[15:0]", EOL);
    DP_BUSE( "tri2", 16, 0, "EN[2]", "Q2[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch1", "D[15:0]", "AND3OUT[1]", 
    "Q1[15:0]", EOL);
    DP_BUSE( "tri1", 16, 0, "EN[1]", "Q1[15:0]", "Q[15:0]", EOL); 
    DP_IMPORT( "dlatch_fpgen", "latch0", "D[15:0]", "AND3OUT[0]", 
    "Q0[15:0]", EOL);
    DP_BUSE( "tri0", 16, 0, "EN[0]", "Q0[15:0]", "Q[15:0]", EOL); 

    DP_SAVLOFIG();
    exit(0);
}    