#include <fpgen.h>

static void ioreg();

#ifdef INSERT_IOREGS
static void ioregs_fpgen()
#else
int main()
#endif
{
  
  ioreg();

  DP_DEFLOFIG("ioregs_fpgen", 16, LSB_INDEX_ZERO);

  /* Data terminals declarations. */
  DP_LOCON( "data_r_literal[15:0]", IN   , "data_r_literal[15:0]" );
  DP_LOCON( "data_r_a_data[15:0]", IN, "data_r_a_data[15:0]" );
  DP_LOCON( "data_r_b_data[15:0]", IN, "data_r_b_data[15:0]" );
  DP_LOCON( "data_ext_data[15:0]", IN, "data_ext_data[15:0]");
//  DP_LOCON( "data_ext_data[15:0]", IN, "dff0_q[15:0]");
  DP_LOCON( "data_e_result[15:0]", IN, "data_e_result[15:0]");

  DP_LOCON( "ctrl_sel_a[3:0]", IN, "ctrl_sel_a[3:0]");
  DP_LOCON( "ctrl_sel_b[3:0]", IN, "ctrl_sel_b[3:0]");
  

  /* -- Clock Connectors */
//  DP_LOCON( "ioregdff0_ck", IN, "dff0_ck");
  DP_LOCON( "ioregdff1_ck", IN, "dff1_ck");
  DP_LOCON( "ioregA_dff0_ck", IN, "ioregA_dff0_ck");
  DP_LOCON( "ioregA_dff1_ck", IN, "ioregA_dff1_ck");
  DP_LOCON( "ioregA_dff2_ck", IN, "ioregA_dff2_ck");
  DP_LOCON( "ioregB_dff0_ck", IN, "ioregB_dff0_ck");
  DP_LOCON( "ioregB_dff1_ck", IN, "ioregB_dff1_ck");
  DP_LOCON( "ioregB_dff2_ck", IN, "ioregB_dff2_ck");
  
  /* -- Write enable
  ** -- Enable writing when set to one*/
//  DP_LOCON( "ioregdff0_wen", IN, "ioregdff0_wen");
  DP_LOCON( "ioregdff1_wen", IN, "ioregdff1_wen");
  DP_LOCON( "ioregA_dff0_wen", IN, "ioregA_dff0_wen");
  DP_LOCON( "ioregA_dff1_wen", IN, "ioregA_dff1_wen");
  DP_LOCON( "ioregA_dff2_wen", IN, "ioregA_dff2_wen");
  DP_LOCON( "ioregB_dff0_wen", IN, "ioregB_dff0_wen");
  DP_LOCON( "ioregB_dff1_wen", IN, "ioregB_dff1_wen");
  DP_LOCON( "ioregB_dff2_wen", IN, "ioregB_dff2_wen");



  DP_LOCON( "data_a[15:0]", OUT, "data_a[15:0]");
  DP_LOCON( "data_b[15:0]", OUT, "data_b[15:0]");
  DP_LOCON( "data_w_c_data[15:0]", OUT, "data_w_c_data[15:0]");
  
  /* Power supplies terminals. */
  DP_LOCON( "vdd", IN   , "vdd" );
  DP_LOCON( "vss", IN   , "vss" );

  DP_TRACE (TRACE_ON);
      


/* ---------------------    IoregA ----------------------------*/

  DP_PDFF( "ioregA_dff1", 16, 0, "ioregA_dff1_wen", "ioregA_dff1_ck", 
                  "data_e_result[15:0]",
		  "ioregA_dff1_q[15:0]",
		  "ioregA_dff1_nq[15:0]", 
		  EOL);

  DP_PDFF( "dff0x", 16, 0, "ioregdff0_wen", "dff0_ck", 
                  "data_ext_data[15:0]",
		  "dff0_q[15:0]",
		  "dff0_nq[15:0]", 
		  EOL);

  DP_BUFF( "ioregA_buff0", 16, 0, 2,
                  "ioregA_dff1_q[15:0]",
		  "NC0[15:0]",
		  EOL);



	
  DP_MUX2CS( "ioregA_mux1", 16, 0, 
                  "ctrl_sel_a[1]",
		  "data_e_result[15:0]",
		  "ioregA_dff1_q[15:0]",
		  "ioregA_mux1_out[15:0]",
		  EOL);

	
  DP_PDFF( "ioregA_dff2", 16, 0, "ioregA_dff2_wen", "ioregA_dff2_ck", 
                  "ioregA_mux1_out[15:0]",
		  "ioregA_dff2_q[15:0]",
		  "ioregA_dff2_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "ioregA_mux2", 16, 0, 
                  "ctrl_sel_a[2]",
		  "dff0_q[15:0]",
		  "ioregA_dff2_q[15:0]",
		  "ioregA_mux2_out[15:0]",
		  EOL);


  DP_PDFF( "ioregA_dff0", 16, 0, "ioregA_dff0_wen", "ioregA_dff0_ck", 
                  "data_r_a_data[15:0]",
		  "ioregA_dff0_q[15:0]",
		  "ioregA_dff0_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "ioregA_mux0", 16, 0, 
                  "ctrl_sel_a[0]",
		  "e_lit[15:0]",
		  "ioregA_dff0_q[15:0]",
		  "ioregA_mux0_out[15:0]",
		  EOL);


  DP_MUX2CS( "ioregA_mux3", 16, 0, 
                  "ctrl_sel_a[3]",
		  "ioregA_mux0_out[15:0]",
		  "ioregA_mux2_out[15:0]",
		  "data_a[15:0]",
		  EOL);

/*------------------   End of  IoregA -------------------------*/

		  

/* ---------------------    IoregB ----------------------------*/
  DP_PDFF( "ioregB_dff1", 16, 0, "ioregB_dff1_wen", "ioregB_dff1_ck", 
                  "data_e_result[15:0]",
		  "ioregB_dff1_q[15:0]",
		  "ioregB_dff1_nq[15:0]", 
		  EOL);

  DP_BUFF( "ioregB_buff0", 16, 0, 2,
                  "ioregB_dff1_q[15:0]",
		  "data_w_c_data[15:0]",
		  EOL);
	
  DP_MUX2CS( "ioregB_mux1", 16, 0, 
                  "ctrl_sel_b[1]",
		  "data_e_result[15:0]",
		  "ioregB_dff1_q[15:0]",
		  "ioregB_mux1_out[15:0]",
		  EOL);
	
  DP_PDFF( "ioregB_dff2", 16, 0, "ioregB_dff2_wen", "ioregB_dff2_ck", 
                  "ioregB_mux1_out[15:0]",
		  "ioregB_dff2_q[15:0]",
		  "ioregB_dff2_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "ioregB_mux2", 16, 0, 
                  "ctrl_sel_b[2]",
		  "dff0_q[15:0]",
		  "ioregB_dff2_q[15:0]",
		  "ioregB_mux2_out[15:0]",
		  EOL);


  DP_PDFF( "ioregB_dff0", 16, 0, "ioregB_dff0_wen", "ioregB_dff0_ck", 
                  "data_r_b_data[15:0]",
		  "ioregB_dff0_q[15:0]",
		  "ioregB_dff0_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "ioregB_mux0", 16, 0, 
                  "ctrl_sel_b[0]",
		  "e_lit[7],e_lit[7],e_lit[7],e_lit[7],e_lit[7],e_lit[7],e_lit[7],e_lit[7],e_lit[7:0]",
		  "ioregB_dff0_q[15:0]",
		  "ioregB_mux0_out[15:0]",
		  EOL);


  DP_MUX2CS( "ioregB_mux3", 16, 0, 
                  "ctrl_sel_b[3]",
		  "ioregB_mux0_out[15:0]",
		  "ioregB_mux2_out[15:0]",
		  "data_b[15:0]",
		  EOL);

/*------------------   End of  IoregB -------------------------*/

  
		  
  DP_PDFF( "dff1x", 16, 0, "ioregdff1_wen", "dff1_ck", 
                  "data_r_literal[15:0]",
		  "e_lit[15:0]",
		  "dff1_nq[15:0]", 
		  EOL);
		  

  DP_TRACE( TRACE_OFF);
  
#ifdef INSERT_IOREGS
    DP_SAVLOFIG();   
#else
    DP_SAVLOFIG();
    exit(0);
#endif
  
  
}



static void ioreg()  // parte de aludp
{ 
  //IO-REG module  Fig. 9.6 Pag. 643	

  DP_DEFLOFIG("ioreg" , 16, LSB_INDEX_ZERO);
    

  /* Data terminals declarations. */
  DP_LOCON( "data_r_lit[15:0]" , IN   , "data_r_lit[15:0]" );
  DP_LOCON( "data_r_reg[15:0]" , IN   , "data_r_reg[15:0]" );
  DP_LOCON( "data_e_ext_data[15:0]" , IN, "data_e_ext_data[15:0]" );
  DP_LOCON( "data_e_result[15:0]", IN, "data_e_result[15:0]");

  DP_LOCON( "ctrl_sel[3:0]", IN, "ctrl_sel[3:0]"); 

  /* -- Clock Connectors 
  */
  DP_LOCON( "ioregdff0_ck", IN, "ioregdff0_ck");
  DP_LOCON( "ioregdff1_ck", IN, "ioregdff1_ck");
  DP_LOCON( "ioregdff2_ck", IN, "ioregdff2_ck");
  
  /* -- Write enable
  ** -- Enable writing when set to one
  */
  DP_LOCON( "ioregdff0_wen", IN, "ioregdff0_wen");
  DP_LOCON( "ioregdff1_wen", IN, "ioregdff1_wen");
  DP_LOCON( "ioregdff2_wen", IN, "ioregdff2_wen");

     
  DP_LOCON( "data_ioreg_out[15:0]"  , OUT   , "data_ioreg_out[15:0]" );
  DP_LOCON( "data_w_result[15:0]", OUT, "data_w_result[15:0]");
//  DP_LOCON( "data_e_reg[15:0]", OUT, "data_e_reg[15:0]");  

  /* Power supplies terminals. */
  DP_LOCON( "vdd", IN   , "vdd" );
  DP_LOCON( "vss", IN   , "vss" );

//  DP_TRACE (TRACE_ON);
      

  DP_PDFF( "dff1", 16, 0, "ioregdff1_wen", "ioregdff1_ck", 
                  "data_e_result[15:0]",
		  "dff1_q[15:0]",
		  "dff1_nq[15:0]", 
		  EOL);

  DP_BUFF( "buff0", 16, 0, 2,
                  "dff1_q[15:0]",
		  "data_w_result[15:0]",
		  EOL);
	
  DP_MUX2CS( "mux1", 16, 0, 
                  "ctrl_sel[1]",
		  "data_e_result[15:0]",
		  "dff1_q[15:0]",
		  "mux1_out[15:0]",
		  EOL);
	
  DP_PDFF( "dff2", 16, 0, "ioregdff2_wen", "ioregdff2_ck", 
                  "mux1_out[15:0]",
		  "dff2_q[15:0]",
		  "dff2_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "mux2", 16, 0, 
                  "ctrl_sel[2]",
		  "data_e_ext_data[15:0]",
		  "dff2_q[15:0]",
		  "mux2_out[15:0]",
		  EOL);


  DP_PDFF( "dff0", 16, 0, "ioregdff0_wen", "ioregdff0_ck", 
                  "data_r_reg[15:0]",
		  "dff0_q[15:0]",
		  "dff0_nq[15:0]", 
		  EOL);

  DP_MUX2CS( "mux0", 16, 0, 
                  "ctrl_sel[0]",
		  "data_r_lit[15:0]",
		  "dff0_q[15:0]",
		  "mux0_out[15:0]",
		  EOL);


  DP_MUX2CS( "mux3", 16, 0, 
                  "ctrl_sel[3]",
		  "mux0_out[15:0]",
		  "mux2_out[15:0]",
		  "data_ioreg_out[15:0]",
		  EOL);
    
//  DP_TRACE( TRACE_OFF);
  DP_SAVLOFIG();

}

